;// FastThomsonvAJX^}CYAA^Cf[^]  \vV[W
;//						NIFS LABCOM
;// gp@
;//	FTMonitor,`lԍ
;//
;// startupt@Cɂ͒ǉȂB
;//
;// printerrormessagevV[WgpĂB
;//
;// date 2020-05-25
PRO	FTMonitor,channelNumber,cport,nsum=nsums,thinning=thinnings,host=dashost,udp=udp,ynum=ynum

	if( n_params(0) eq 1) then begin
		cport = long(-1)
	endif
	!Y.range=[1,3999]
	WaveMon,'FastThomson',channelNumber,cport,nsum=nsums,thinning=thinnings,host=dashost,udp=udp,ynum=ynum,ysize=540
END
;//	g`pvV[W
PRO	WaveMon,diagName,channelNumber,cport,nsum=nsums,thinning=thinnings,host=dashost,udp=udp,ynum=ynum,xsize=xsize,ysize=ysize
	usage = 0
	if( KEYWORD_SET(dashost) ) then begin
		ttype = size(dashost)
		if( 7 ne ttype(1) ) then begin
			usage = 1
		endif
	endif
	
	if( not KEYWORD_SET(xsize) ) then begin
		xsize=640
	endif
	if( not KEYWORD_SET(ysize) ) then begin
		ysize=480
	endif
	if( n_params(0) ne 3 ) AND ( n_params(0) ne 2) then begin
		usage = 1
	endif

	if( 1 eq usage ) then begin
		print, 'Usage:'

		print, '  FTMonitor,chNumber[,portNumber][,nsum=N][,thinning=N][,host=HostName][,/udp]'

		print, ' '
		print, 'Input Parameters:'
		print, '  < chNumber       - Channel number'
		print, '  < portNumber     - CONTROL port number'
		print, '  < nsum=N         - plot average of N samples'
		print, '  < thinning=T     - set transfer thinning rate to 1/T'
		print, '  < host=HostName  - Host name (''DAS15'',.., etc.)'
		print, '  < /udp           - data transfer by UDP'
		
		retall
	endif
	
	if( n_params(0) eq 2) then begin
		ctrl_port = long(-1)
	endif else begin
		ctrl_port = long(cport)
	endelse
	
	ns = 1
	if( KEYWORD_SET(nsums) ) then begin
		ns = nsums
	endif
	;//	Ԉ̐ݒ
	thin_type=fix(1);
	thinning = long(1)
	if( KEYWORD_SET(thinnings) ) then begin
		thinning = long(thinnings)
	endif
	ch_list = string(channelNumber,FORMAT='(i0)')
	
	
	if (KEYWORD_SET(udp)) then begin
		packet_size = 0L
	endif else begin
		packet_size = -1L
	endelse

	
	print,'Terminate when "q" or "Q" is entered.'

	;//	DLL̂ꏊw
	if( !version.arch eq 'x86_64' or !version.arch eq 'x64') then object = !Retrieve + '/bin64/RTTransClientDLL.dll' $
	else object = !Retrieve + '/bin/RTTransClientDLL.dll'

	;//	ꂼDLL֐w
	symbol_Start	= 'PvwRTCStart'
	symbol_End		= 'PvwRTCEnd'
	symbol_Open		= 'PvwRTCopen'
	symbol_GetParam = 'PvwRTCgetChannelParam'
	symbol_Close	= 'PvwRTCclose'
	symbol_GetData	= 'PvwRTCgetChannelData'
	symbol_GetChParam = 'PvwRTCgetChannelKeyParam'
	symbol_Transfer	= 'PvwRTCtransfer'

;//	symbol_Verbose = 'PvwRTCerrorVerbose'
;//	rtd = LINKNLOAD( object, symbol_Verbose,1)


	rtd = long(0)

	;//	DLL֐ɃANZXAl擾ϐ̗̈m
	status = long(0)
	samplingInterval = long(0)
	valueLen = 0
	recLen = long(0)

	tmp_interval = long(0)
	tmp_valuelen = long(0)
	tmp_reclen = long(0)
	
	result = LINKNLOAD( object, symbol_Start)
	if( KEYWORD_SET(dashost) ) then begin
		diag_name=''
	endif else begin
		diag_name=diagName
		dashost=''
	endelse
	rtd = LINKNLOAD( object, symbol_Open,$
					diag_name, dashost, ch_list, ctrl_port, packet_size, thinning, thin_type)
	if (rtd le 0) then begin
		printerrormessage, rtd
		retall
	endif

	;//	p[^擾
	status = LINKNLOAD( object, symbol_GetParam,$
						rtd, channelNumber, samplingInterval, valueLen, recLen)
	if (status lt 0) then begin
		printerrormessage, status
		result = LINKNLOAD( object, symbol_Close, rtd)
		retall
	endif

	
	imageType = bytarr(256)
	result = LINKNLOAD( object, symbol_GetChParam,$
						rtd, channelNumber, 'ImageType', imageType, 256L)
	if (result ne 0) then begin
		printerrormessage, result
		result = LINKNLOAD( object, symbol_Close, rtd)
		retall
	endif
	sImageType = string(imageType)
	if( sImageType eq 'IllegalParameterName' ) then begin
		print,'Format is unkown(valueLen:' + string(valueLen,format='(I2)') + ').'
	endif else begin
		print,'Format is '+ sImageType +'(valueLen:' + string(valueLen,format='(I2)') + ').';
	endelse
	if (valueLen le 8) then begin
		bytePerSample = 1
		ttype = 1; BYTE
	endif else if (valueLen le 16) then begin
		bytePerSample = 2
		ttype = 2;	INT(SHORT)
	endif else if (valueLen le 32) then begin
		bytePerSample = 4
		if( 'FLT32' eq sImageType ) then begin
			ttype = 4; FLOAT
		endif else begin
			if( !Version.release gt 9.0 ) then begin
				ttype = 13; I32
			end else begin
				ttype = 3; LONG
			endelse
		endelse
	endif else if (valueLen le 64) then begin
		bytePerSample = 8
		if( 'FLT64' eq sImageType ) then begin
			ttype = 5; DOUBLE
		endif else begin
			ttype = 3; LONG
		endelse
	endif

	bufsize = recLen/bytePerSample
	buf    = make_array(bufsize, type=ttype)
	if (KEYWORD_SET(ynum)) then begin
		if( ynum le bufsize ) then begin
			points=bufsize
		endif else begin
			points=ynum
			ybuf    = make_array(ynum, type=ttype)
		endelse
	endif else begin
		points=bufsize
	endelse
	window, 1,ysize=ysize,xsize=xsize
	wshow, 1, 1

	;//	f[^MۂɁAVbgԍȂǂ󂯎邽߂̗̈m
	shot = long(0);
	subshot = long(0);

	;//	ubNԍ1n܂AT[o玟̃ubN
	;//	Ă邲ƂɃV[PVɑĂ܂
	blk = long(0);
	preblk = long(-1);

	;//	MubN̐擪ƍŏITvOf[^
	;//	Wf[^ŉԖڂɂ邩܂
	head = long(0);
	tail = long(0);

	result = LINKNLOAD( object, symbol_Transfer, rtd, 1);
	blen = long(10);
    timeout = long(100); // msec
    lossblk=0L
    
	yidx=0L
	REPEAT BEGIN

		;//	f[^M֐Ăяo
		result = LINKNLOAD( object, symbol_GetData, rtd, channelNumber, timeout, status, shot, subshot, blk, head, tail, buf, blen)
		
		if( result EQ 0 ) then begin
			if ( status EQ 8 ) AND ( blen GT 0 )then begin
				if preblk LT blk then begin
					buflen = blen/bytePerSample
					bufidx = buflen-1
					if( points le bufsize ) then begin
						plot, buf(0:bufidx), nsum = ns, Title = diagName+' SHOT#'+string(shot,format='(i0)')+' CH#'+string(channelNumber,format='(i0)')+' Event#'+string(blk,format='(i0)')
					endif else begin
						ybuf(0:points-buflen-1)=ybuf(buflen:points-1)
						ybuf(points-buflen:points-1)= buf(0:bufidx);
						plot, ybuf, nsum = ns, Title = diagName+' SHOT#'+string(shot,format='(i0)')+' CH#'+string(channelNumber,format='(i0)')
					endelse
					wait, 0.001
				endif
				if( 0 NE blk ) then begin
				    preblk = preblk+1
					if( preblk NE blk ) then begin
						print,"LOSS BLOCK:",preblk
						lossblk= lossblk+1
					endif
				endif
				
			endif else begin
				print,shot, subshot,status,blk,blen
				if ( status EQ 3 ) then begin
					status = LINKNLOAD( object, symbol_GetParam,$
										rtd, channelNumber, tmp_interval, tmp_valuelen, tmp_reclen)
					if (status ge 0 AND recLen NE tmp_reclen) then begin
						recLen=tmp_reclen
						bufsize=recLen/bytePerSample
						buf    = make_array(bufsize, type=ttype)
						if (KEYWORD_SET(ynum)) then begin
							if( ynum le bufsize ) then begin
								points=bufsize
							endif else begin
								points=ynum
								ybuf    = make_array(ynum, type=ttype)
							endelse
						endif else begin
							points=bufsize
						endelse
					endif
				endif
			endelse
			preblk=blk
		endif else if( result EQ 2 ) then begin
			print,'RTTRANSD STOPPED'
			GOTO, STOP_PRO
		endif
	quit = GET_KBRD(0)
	ENDREP UNTIL STRLOWCASE(quit) EQ 'q' 

STOP_PRO:
	result = LINKNLOAD( object, symbol_Transfer, rtd, 0);
	print,'Number of loss block:',lossblk
	;//	ʐMIۂ̏
	;//	T[oƂ̐ڑN[Y
	result = LINKNLOAD( object, symbol_Close, rtd)

	;//	DLL ̏Iw
	result = LINKNLOAD( object, symbol_End)
END
